Super Jumping! Jumping! Jumping! (动态规划+最大上升序列)

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 2
4 1 2 3 4
4 3 3 2 1
0

Sample Output

4
10
3

题解:

最大上升序列,而不是最长上升序列,该序列一定是递增,但不一定连续。

动态规划,用dp[ i ]记录直到该位置的上升序列的最大值。

例如:a[0]=1,a[1]=3 ,a[2]= 2

          dp[0]初始化为a[0],即dp[0]=1。

          从1位置开始,因为a[1]>a[0],所以dp[1]=max(dp[1],dp[0]+a[1]),即dp[1]=4

          到位置2的时候,先把a[0]与a[2]比较,因为a[2]>a[0],所以dp[2]=max(dp[2],dp[0]+a[2]),即dp[2]=3

                                        再把a[1]与a[2]比较,因为a[2]<a[1],所以dp[2]=max(dp[2],a[2]),即dp[2]=3

         最后找出dp数组中最大的数,即为答案。

代码如下:

#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <cmath>
#include <stack>
#include <queue>
#include <stack>
#define MAX 0x3f3f3f3f
using namespace std;
typedef long long ll;
long long a[1111],dp[1111];
int main()
{

    int n;
    while(cin >> n && n)
    {
        memset(dp,0,sizeof(dp));
        for(int i=0;i<n;i++)
            cin >> a[i];
        dp[0]=a[0];
        for(int i=1;i<n;i++)
        {
            for(int j=0;j<i;j++)
            {
                if(a[i]>a[j])
                    dp[i]=max(dp[i],dp[j]+a[i]);
                else
                    dp[i]=max(a[i],dp[i]);
            }
        }
        sort(dp,dp+n);
        cout << dp[n-1] << endl;
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/m_y_y_/article/details/81205110
今日推荐